package commons.pfc;

import java.util.ArrayList;
import java.util.Vector;

import android.app.ProgressDialog;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class seleccion_distancia_monumentos extends AndromediacommonsActivity {
	
	ListView lv;
	ProgressDialog progressBarMonumentes;
	int progressBarStatus;
	//String distancia;
	Intent intent1 = new Intent();
	Intent intent2 = new Intent();
	
	@Override
    public void onCreate(Bundle savedInstanceState) 
	{
        super.onCreate(savedInstanceState);
        setContentView(R.layout.layout_seleccion_distancia_monumentos);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
        
        inicializar();
	}
	
	private void inicializar()
	{
		String dist = "100,200,300,400,500,1000,1500,2000,2500,3000,6000";
		String[] distancias= dist.split(",");
		
		intent1.setComponent(new ComponentName(this, seleccion_monumento.class));
		intent2.setComponent(new ComponentName(this, mapa_monumentos.class));
		
		ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, distancias);
		lv = (ListView)findViewById(R.id.lista_distancias);
		lv.setAdapter(adaptador);
		lv.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View v, int posicion, long id){
			    
				//distancia = (String) lv.getItemAtPosition(posicion);
				datos.distancia = (String) lv.getItemAtPosition(posicion);
				
				String texto = getString(R.string.txt_progressbar_distancia);
				// preparando el cuadro de dialogo
				progressBarMonumentes = new ProgressDialog(v.getContext());
				progressBarMonumentes.setCancelable(true);
				progressBarMonumentes.setMessage(texto + "...");
				progressBarMonumentes.setProgressStyle(ProgressDialog.STYLE_SPINNER);
				progressBarMonumentes.setProgress(0);
				progressBarMonumentes.setMax(100);
				progressBarMonumentes.show();
				progressBarStatus = 0;//cuadro de dialogo a 0
				
				new Thread(new Runnable() 
				{
				  @Override
				public void run() 
				  {
					while (progressBarStatus < 100) 
					{			 
						// Empieza la tarea en segundo plano.
						try { progressBarStatus = Obtener_Lista_Monumentos(); }
						catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
					// Imagen subida
					if (progressBarStatus >= 100) 
						{
							progressBarMonumentes.dismiss();
							if (datos.wikimonuments)
							{
								datos.distancia_seleccionada = true;
								startActivity(intent1);
							}
							else
							{
								startActivity(intent2);
							}
						}
				  }
				}).start();
				
				
			}
		});
	}
	
	private int Obtener_Lista_Monumentos() throws Exception
	{
		
			String url =""; 
			
			if(datos.concurso)
				url = "http://toolserver.org/~erfgoed/api/api.php?action=search&coord=" + datos.latitud + "," + datos.longitud + "&radius=" + datos.distancia + "&format=xml&limit=100000"; //Busco cualquier monumento al que subir la imagen
			else
				url = "http://toolserver.org/~erfgoed/api/api.php?action=search&coord=" + datos.latitud + "," + datos.longitud + "&radius=" + datos.distancia + "&srimage=&format=xml&limit=100000";//Busco monumentos sin imagenes		
		//String url ="https://toolserver.org/~erfgoed/api/api.php?action=search&coord=" + datos.latitud + "," +datos.longitud + "&radius=" + distancia + "&srimage=&format=xml&limit=100000";
			//http://wlm.wikimedia.org/api/api.php
		//URL de los munumentos que se encuentran en un radio de x distancia
			if(usuario.monumentos == null)
				usuario.monumentos = new Vector<StringBuilder>();
		usuario.love(url);//obtiene los datos de la API
		
		if(lista_imagenes == null)
			lista_imagenes = new ArrayList<datos_imagen_wiki_love>();
			
		for(int i = 0; i < usuario.monumentos.size(); ++i)
		{
			String[] texto = usuario.monumentos.elementAt(i).toString().split("<monument ");
			//texto contiene un monumento con todos sus datos por cada posicion del array de string
			for(int j = 1; j<texto.length; ++j )
			{//Aqui tendria que controlar el la excepcion que aparece cuando al hacer el split, source esta vacio y por lo tanto no devuelve posicion 1 en el aux1
				String[] aux; String[] BIC; String[] municipio; String[] latitud; String[] dominio;//Cada uno de los campos que necesito
				String[] longitud; String[] imagen; String[] lista; String distancia; String[] monumento;
				//Separo para quedarme en la primera posicin con e dato concreto
				aux = texto[j].split("id=");
				BIC = aux[1].split("adm0");
				aux = texto[j].split("municipality=");
				municipio = aux[1].split("lat");
				aux = texto[j].split("lat=");
				latitud = aux[1].split("lon");
				aux = texto[j].split("lon=");
				longitud = aux[1].split("image");
				aux = texto[j].split("image=");
				imagen = aux[1].split("source");
				aux = texto[j].split("title=");
				lista = aux[1].split("&amp");
				aux = texto[j].split("dist=");
				distancia = aux[1].substring(0, aux[1].length()-2);
				aux = texto[j].split("name=");
				monumento = aux[1].split("address");
				aux = texto[j].split("source=\"https://");
				dominio = aux[1].split("/w/index");
				
				if(imagen[0].length()<=4)//compruebo si el dato imagen contene valor
				{
					datos_imagen_wiki_love d_img = new datos_imagen_wiki_love();
					if(distancia.length() < 3)
						distancia="0";
					d_img.distancia = distancia;
					d_img.lat = latitud[0].substring(1, latitud[0].length()-1);//elimino las ""
					d_img.lista = lista[0];
					d_img.lon = longitud[0].substring(1, longitud[0].length()-1);
					d_img.municipio = municipio[0];
					d_img.nom_imagen = imagen[0];
					d_img.BIC = BIC[0];
					d_img.nom_monumento = monumento[0];
					d_img.dominio = dominio[0];
					
					
					lista_imagenes.add(d_img);//Lista de imagenes dentro de la distancia establecida
				}
			}
		}		
		return 100;
	}
	
	@Override
    public void onBackPressed()
    {
		Intent intent = new Intent();
		 usuario.monumentos = null;
	    //datos.ReiniciarDatos();
	    lista_imagenes = null;
	    datos.ReiniciarDatos();
	    
		intent.setComponent(new ComponentName(this, modo_captura.class));
		startActivity(intent);
    }
}
